#include <SPI.h>
#include <Wire.h>
#include <max6675.h>
//#include <MAX6675_01.h>
#include <EEPROM.h>
#include <PID_v1.h>

#include "Adafruit_GFX.h"
#include "Adafruit_ILI9341.h"

// For the Adafruit shield, these are the default.
// Use hardware SPI (on Uno, #13, #12, #11) and the above for CS/DC
// If using the breakout, change pins as desired
//Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC, TFT_MOSI, TFT_CLK, TFT_RST, TFT_MISO);
#define TFT_DC 9
#define TFT_CS 10
Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC);
#define Bkgrnd_color ILI9341_LIGHTGREY

volatile int curCount = 0;

//current editing step pointer
int editStep = 0;

int buzzerPin = 4;//8;

//Назначаем пины кнопок управления
int upSwitchPin     = A0;
int downSwitchPin   = A1;
int cancelSwitchPin = A2;
int okSwitchPin     = A3;

#define RelayPin1 A4  //назначаем пин "ВЕРХНЕГО" нагревателя
#define RelayPin2 A5  //назначаем пин "НИЖНЕГО" нагревателя

int er1=1;
int er2=1;
int reg1;
int reg2;
boolean out1;
boolean out2;
int pwr_TOP;     //максимальная мощность верхнего нагревателя
int pwr_BOTTOM;  //максимальная мощность нижнего нагревателя

//состояние кнопок по умолчанию
int upSwitchState = 0;
int downSwitchState = 0;
int cancelSwitchState = 0;
int okSwitchState = 0;

//переменные для кнопок
long ms_button = 0;
boolean  button_state = false;
boolean  button_long_state = false;

//profile stuff
byte currentProfile = 1;
int currentStep = 1;
byte profileSteps = 2;

double rampRateStep[9];
int dwellTimerStep[9];

double kp1 = 3;
double ki1 = 0;
double kd1 = 20;
double kp2 = 3;
double ki2 = 0;
double kd2 = 20;

int setpointRamp = 240;
double startTemp;
boolean TopStart = false;
boolean flag = 0;  //флаг для фиксации стартовой температуры
int x=1;  //переменная для перехода на нужный шаг при горячей плате
int temperatureStep[9] = {200, 205, 210, 220, 230, 230, 235, 240, 245};
int eepromAddress = 0;//начало eepromaddress

long previousMillis; //это для счетчиков

double counter;

//these are the different states of the sketch. We call different ones depending on conditions
// ***** TYPE DEFINITIONS *****
typedef enum REFLOW_STATE
{
  REFLOW_STATE_IDLE,
  REFLOW_STATE_MENU_STEPS,
  REFLOW_STATE_MENU_BOTTOM_HEAT,
  REFLOW_STATE_MENU_BOTTOM_PWR,
  REFLOW_STATE_MENU_STEP_RAMP,
  REFLOW_STATE_MENU_STEP_TARGET,
  REFLOW_STATE_MENU_TOP_PWR,
  REFLOW_STATE_MENU_STEP_DWELL,
  REFLOW_STATE_MENU_BOTTOM_P,
  REFLOW_STATE_MENU_BOTTOM_I,
  REFLOW_STATE_MENU_BOTTOM_D,
  REFLOW_STATE_MENU_TOP_P,
  REFLOW_STATE_MENU_TOP_I,
  REFLOW_STATE_MENU_TOP_D,
  REFLOW_STATE_STEP_RAMP,
  REFLOW_STATE_STEP,
  REFLOW_STATE_STEP_DWELL,
  REFLOW_STATE_COMPLETE,
  REFLOW_STATE_ERROR
}
reflowState_t;

typedef enum REFLOW_STATUS //this is simply to check if reflow should be running or not
{
  REFLOW_STATUS_OFF,
  REFLOW_STATUS_ON
}
reflowStatus_t;

#define SENSOR_SAMPLING_TIME 1000 //частота обновления текущей температуры (1000=1раз в секунду)
#define GRAPHICS_SAMPLING_TIME 500 //скорость движения "звёздочек" при пайке

reflowStatus_t reflowStatus;// Reflow oven controller state machine state variable
reflowState_t reflowState;


//TC read timer variables
unsigned long nextCheck1;
unsigned long nextRead1;//переменная для обновления текущей температуры
unsigned long nextRead2;//переменная для движения "звёздочек" при пайке

//PID stuff
double Setpoint1, Input1, Output1;//Specify the links and initial tuning parameters
PID myPID1(&Input1, &Output1, &Setpoint1, kp1, ki1, kd1, DIRECT);
int WindowSize = 500;
unsigned long windowStartTime;
//PID stuff
double Setpoint2 = 150, Input2, Output2;//Specify the links and initial tuning parameters
PID myPID2(&Input2, &Output2, &Setpoint2, kp2, ki2, kd2, DIRECT);

boolean alarmOn = false;//Alarm state boolean
boolean updateScreen = true;//Update whole screen boolean

//назначаем пины усилителя термопары MAX6675 "НИЖНЕГО" нагревателя
int thermoCLK     = 7; //SCK
//int thermoCLK     = 7; //SCK
int thermoSO      = 5; //DO
//int thermoSO      = 5; //DO
int thermoCSbott  = 6; //CS
int thermoCStop  = 6; //CS
//назначаем пины усилителя термопары MAX6675 "ВЕРХНЕГО" нагревателя
//int thermoCStop   = 10;
MAX6675 thermocouple1(thermoCLK, thermoCStop, thermoSO); //термопара "ВЕРХНЕГО" нагревателя
MAX6675 thermocouple2(thermoCLK, thermoCSbott, thermoSO);//термопара "НИЖНЕГО"  нагревателя

//MAX6675(int CS_pin, int SO_pin, int SCK_pin, int units, float error);
//int units = 1;    // Units to readout temp (0 = ?F, 1 = ?C)
//float error1 = 0.0; // Temperature compensation error
//float error2 = 0.0; // Temperature compensation error

// переменные для калмана "ВЕРХНЕГО" нагревателя
float varTerm1 = 0.25;  // среднее отклонение (ищем в excel)
float varProcess1 = 0.0125; // скорость реакции на изменение (подбирается вручную)
float Pc1 = 0.0;
float G1 = 0.0;
float P1 = 1.0;
float Xp1 = 0.0;
float Zp1 = 0.0;
float Xe1 = 0.0;

// переменные для калмана "НИЖНЕГО" нагревателя
float varTerm2 = 0.25;  // среднее отклонение (ищем в excel)
float varProcess2 = 0.0125; // скорость реакции на изменение (подбирается вручную)
float Pc2 = 0.0;
float G2 = 0.0;
float P2 = 1.0;
float Xp2 = 0.0;
float Zp2 = 0.0;
float Xe2 = 0.0;
// переменные для калм
int tc1;
int tc2;
int tc1_old;
int tc2_old;

int i = 0;







void setup()
{
  tft.begin();
  tft.setRotation(3);
  tft.fillScreen(Bkgrnd_color);
  //tft.fillRect(0, 0, 320, 240, Bkgrnd_color);//lcd.clear();
  tft.setCursor(20, 5);
  tft.setTextColor(ILI9341_NAVY);  tft.setTextSize(4);
  tft.println("ARS UNO v1m2");
  tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);

  // colors ILI9341
  // ILI9341_BLACK       0x0000      /*   0,   0,   0 */
  // ILI9341_NAVY        0x000F      /*   0,   0, 128 */
  // ILI9341_DARKGREEN   0x03E0      /*   0, 128,   0 */
  // ILI9341_DARKCYAN    0x03EF      /*   0, 128, 128 */
  // ILI9341_MAROON      0x7800      /* 128,   0,   0 */
  // ILI9341_PURPLE      0x780F      /* 128,   0, 128 */
  // ILI9341_OLIVE       0x7BE0      /* 128, 128,   0 */
  // ILI9341_LIGHTGREY   0xC618      /* 192, 192, 192 */
  // ILI9341_DARKGREY    0x7BEF      /* 128, 128, 128 */
  // ILI9341_BLUE        0x001F      /*   0,   0, 255 */
  // ILI9341_GREEN       0x07E0      /*   0, 255,   0 */
  // ILI9341_CYAN        0x07FF      /*   0, 255, 255 */
  // ILI9341_RED         0xF800      /* 255,   0,   0 */
  // ILI9341_MAGENTA     0xF81F      /* 255,   0, 255 */
  // ILI9341_YELLOW      0xFFE0      /* 255, 255,   0 */
  // ILI9341_WHITE       0xFFFF      /* 255, 255, 255 */
  // ILI9341_ORANGE      0xFD20      /* 255, 165,   0 */
  // ILI9341_GREENYELLOW 0xAFE5      /* 173, 255,  47 */
  // ILI9341_PINK        0xF81F

  pinMode (upSwitchPin, INPUT);
  digitalWrite(upSwitchPin, HIGH); //подключаем подтягивающий резистор
  pinMode (downSwitchPin, INPUT);
  digitalWrite(downSwitchPin, HIGH); //подключаем подтягивающий резистор
  pinMode (cancelSwitchPin, INPUT);
  digitalWrite(cancelSwitchPin, HIGH); //подключаем подтягивающий резистор
  pinMode (okSwitchPin, INPUT);
  digitalWrite(okSwitchPin, HIGH); //подключаем подтягивающий резистор
  pinMode (buzzerPin, OUTPUT);
  pinMode(RelayPin1, OUTPUT);//setup ssr pins as outputs
  pinMode(RelayPin2, OUTPUT);
  /////////////////////////////////////////////
  
  saveProfile();
  
  /////////////////////////////////////////////
  //lcd.begin();//setup lcd
  //lcd.begin(20,4); // for PCF8574
  //lcd.clear();
  //lcd.setCursor(1, 1);
  //lcd.print("ARDUINO REWORK v1.3        MAX6675");
  //TFT_BL_ON;
  //Tft.TFTinit();
  //Tft.drawString("ARS UNO v1.m2",0,20,3,CYAN);

  //Serial.begin(9600);
  //Serial.println("ILI9341 Test!"); 
  

  /*
  // read diagnostics (optional but can help debug problems)
  uint8_t x = tft.readcommand8(ILI9341_RDMODE);
  Serial.print("Display Power Mode: 0x"); Serial.println(x, HEX);
  x = tft.readcommand8(ILI9341_RDMADCTL);
  Serial.print("MADCTL Mode: 0x"); Serial.println(x, HEX);
  x = tft.readcommand8(ILI9341_RDPIXFMT);
  Serial.print("Pixel Format: 0x"); Serial.println(x, HEX);
  x = tft.readcommand8(ILI9341_RDIMGFMT);
  Serial.print("Image Format: 0x"); Serial.println(x, HEX);
  x = tft.readcommand8(ILI9341_RDSELFDIAG);
  Serial.print("Self Diagnostic: 0x"); Serial.println(x, HEX); 
  */

  //Мелодия приветствия
  tone(buzzerPin, 523);
  delay(200);
  tone(buzzerPin, 659);
  delay(200);
  tone(buzzerPin, 784);
  delay(200);
  tone(buzzerPin, 1046);
  delay(200);
  noTone(buzzerPin);
  // wait for MAX chips to stabilize and splash screen
  delay(500);
  //lcd.clear();


  windowStartTime = millis();//Just total time sketch has been running
  // Initialize time keeping variable for TC1
  nextCheck1 = millis();
  // Initialize  top thermocouple reading variable
  nextRead1 = millis();

  //initialize soak timer variable


  myPID1.SetOutputLimits(0, WindowSize);//myPID1 = top heater PID loop
  myPID2.SetOutputLimits(0, WindowSize);
  myPID1.SetMode(AUTOMATIC);
  myPID2.SetMode(AUTOMATIC);

  //attachInterrupt(1, Dimming, RISING); // настроить порт прерывания(0 или 1) 2й или 3й цифровой пин
}


void loop()
{
  //Считываем состояние кнопок управления
  upSwitchState = digitalRead(upSwitchPin);
  downSwitchState = digitalRead(downSwitchPin);
  cancelSwitchState = digitalRead(cancelSwitchPin);
  okSwitchState = digitalRead(okSwitchPin);
  //----------------------------------------------------------------------------------
  if (upSwitchState == HIGH) {
    upSwitchState = LOW;
  } else {
    upSwitchState = HIGH;
   
  }
  if (downSwitchState == HIGH) {
    downSwitchState = LOW;
  } else {
    downSwitchState = HIGH;
  }
  if (cancelSwitchState == HIGH) {
    cancelSwitchState = LOW;
  } else {
    cancelSwitchState = HIGH;
  }
  if (okSwitchState == HIGH) {
    okSwitchState = LOW;
  } else {
    okSwitchState = HIGH; 
  }
//-------------------------------------------------------------------------------

  unsigned long currentMillis = millis();
  
    
  int SP1 = Setpoint1;
  int SP2 = Setpoint2;

//отключил бузер при нажатии на кнопки (нервирует), кому надо раскоментируйте ниже 6 строк
  if (upSwitchState == HIGH || downSwitchState == HIGH || cancelSwitchState == HIGH || okSwitchState == HIGH)
  {
    tone(buzzerPin, 1045);
    delay(100);
    noTone(buzzerPin);
  }


  if (reflowState == REFLOW_STATE_COMPLETE || alarmOn) {
    if (i < 2 && cancelSwitchState == LOW) {
      alarmOn = true;
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      i++;
    }
    else {
      i = 0;
      alarmOn = false;
    }
  }

  switch (reflowState)
  {
    case REFLOW_STATE_IDLE:
      TopStart = false;
      currentStep = 1;
      counter = 0;
      setpointRamp = 0;
      x = 1;             //устанавливаем переменную в исходное состояние
      flag = 0;         //после отановки профиля сбрасываем флаг
      Output1=0;
      Output2=0;

      if (millis() > nextRead1)
      {
        // Read thermocouples next sampling period
        nextRead1 += SENSOR_SAMPLING_TIME;
        Input1 = filter1(thermocouple1.readCelsius());
        Input2 = filter2(thermocouple2.readCelsius());
        tc1 = Input1;
        tc2 = Input2;
        
        //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
        if ( tc1 != tc1_old )
        {
          tft.setCursor(16*16+5, 2*48+48); //lcd.setCursor(16, 2);
          tft.print("   ");
          tft.setCursor(16*16+5, 2*48+48);
          tft.print(tc1);
        }
        if ( tc2 != tc2_old )
        {        
          tft.setCursor(16*16+5, 3*48+48); //lcd.setCursor(16, 3);
          tft.print("   ");
          tft.setCursor(16*16+5, 3*48+48);
          tft.print(tc2);
        }
        //lcd.print("    ");
        //lcd.setCursor(16, 2);
        //if (isnan(Input1)) {
        //  lcd.print("Er");
        //} else {
        //  lcd.print(tc1);
        //}
        //lcd.setCursor(16, 3);
        //lcd.print("    ");
        //lcd.setCursor(16, 3);
        //if (isnan(Input2)) {
        //  lcd.print("Er");
        //} else {
        //  lcd.print(tc2);
        //}
      }

      //Update whole screen only once
      if (updateScreen) {
        //Настройка экрана в режиме ожидания
        tft.fillRect(0, 48, 320, 240-96, Bkgrnd_color);//lcd.clear();
        //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
        tft.setCursor(8*16, 0*48+48); //lcd.setCursor(8, 0);
        tft.print("IDLE");            //lcd.print("IDLE");
        //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
        tft.setCursor(1*16+2, 1*48+48); //lcd.setCursor(1, 1);
        tft.print("PTN:      STEP:1 ");            //lcd.print("PTN:");
        //tft.print("      STEP:1 ");   //lcd.print("      STEP:1 ");
        //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
        tft.setCursor(0*16, 2*48+48); //lcd.setCursor(0, 2);
        tft.print(" TH SP:");        //lcd.print(" TH  SP:");
        tft.setCursor(13*16, 2*48+48);//lcd.setCursor(13, 2);
        tft.print(char(30));tft.print("T:   ");  //lcd.print("PV:"); код=30=1EH
        tft.setCursor(0*16, 3*48+48); //lcd.setCursor(0, 3);
        tft.print(" BH SP:    ");        //lcd.print(" BH  SP:");
        tft.setCursor(13*16, 3*48+48);//lcd.setCursor(13, 3);
        tft.print(char(31));tft.print("T:   "); //lcd.print("PV:"); код=31=1FH
        tft.setCursor(8*16, 3*48+48);   //lcd.setCursor(8, 3);
        tft.print(SP2);                 //lcd.print(SP2);
        tft.print(" ");//lcd.print(" ");*/
        updateScreen = false;
      }
      //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
      tft.setCursor(6*16, 1*48+48);   //lcd.setCursor(5, 1);6
      tft.print(currentProfile);      //lcd.print(currentProfile);
      //lcd.print(" ");
      tft.setCursor(8*16, 2*48+48);   //lcd.setCursor(8, 2);
      tft.print(temperatureStep[0]);  //lcd.print(temperatureStep[0]);
      //lcd.print(" ");
      tft.setCursor(8*16, 3*48+48);   //lcd.setCursor(8, 3);
      tft.print(SP2);                 //lcd.print(SP2);
      tft.print("  ");//lcd.print(" ");*/
      tft.setCursor(13*16, 3*48+48);
      tft.print(char(31));
      windowStartTime = millis();
      
      if (upSwitchState == HIGH && ( millis() - ms_button)>500)//if up switch is pressed go to next profile
      {
        ms_button =  millis();
        if (++currentProfile >= 5) { currentProfile = 1; }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>500)//same as above just go down one profile
      {
        ms_button =  millis();
        if (--currentProfile <= 0) { currentProfile = 4; }
      }
      loadProfile();//call the loadProfile function to load from eeprom
      
//фиксируем момент нажатия кнопки "ОК" + защита от дребезга
      if (okSwitchState/* == HIGH*/ && !button_state && (( millis() - ms_button)>100))
      {
        ms_button =  millis();
        button_state = true;
        button_long_state = false;
      }
//держим "ОК" 3секунды и заходим в меню настроек      
      if (okSwitchState /*== HIGH*/ && !button_long_state && (( millis() - ms_button)>3000))
      {
        button_long_state = true;
        button_state = false;
        reflowState = REFLOW_STATE_MENU_STEPS;
        //update next screen
        updateScreen = true;
      }
//включаем пайку, кнопка сработает после отпускания "ОК"       
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        tone(buzzerPin, 1045, 500);  //звуковой сигнал при старте профиля
        //update next screen
        updateScreen = true;
        curCount = 0;
        nextRead2 = millis();
        reflowStatus = REFLOW_STATUS_ON;
        reflowState = REFLOW_STATE_STEP_RAMP;
      }

      break;
//устанавливаем количество шагов профиля
    case REFLOW_STATE_MENU_STEPS:
      if (updateScreen)
      {
        tft.fillRect(0, 48, 320, 240-48, Bkgrnd_color);//lcd.clear();
        //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
        tft.setCursor(0*16+5, 0*48+48); //lcd.setCursor(3, 0);2
        tft.print("Profile:");        //lcd.print("Profile ");
        tft.setCursor(10*16, 0*48+48);
        tft.print(currentProfile);    //lcd.print(currentProfile);
        tft.setCursor(13*16, 0*48+48);
        tft.print("Edit");           //lcd.print(" Edit");
        //tft.setCursor(0*16, 1*48+48); //lcd.setCursor(0, 1);
        //tft.print("                    ");//lcd.print("                    ");
        tft.setCursor(0*16+5, 2*48+48); //lcd.setCursor(2, 2);0
        tft.print("Profile Steps:    " );//lcd.print("Profile Steps: ");
        tft.setCursor(16*16, 2*48+48);  //lcd.setCursor(17, 2);16
        tft.print(profileSteps);        //lcd.print(profileSteps);
        updateScreen = false;
     }
      
      //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
      //tft.setCursor(17*16+14, 2*48+48);  //lcd.setCursor(17, 2);16
      //tft.print("  ");        //lcd.print(profileSteps);
      tft.setCursor(16*16, 2*48+48);  //lcd.setCursor(17, 2);16
      tft.print(profileSteps);        //lcd.print(profileSteps);

      if (upSwitchState == HIGH && (( millis() - ms_button)>100))
      {
        ms_button =  millis();
        //profileSteps = profileSteps + 1;
        if (++profileSteps >= 10) { profileSteps = 1; }
      }
      if (downSwitchState == HIGH && (( millis() - ms_button)>100))
      {
        ms_button =  millis();
        //profileSteps = profileSteps - 1;
        if (--profileSteps <= 0) { profileSteps = 9;  }
      }
      if (okSwitchState == LOW && button_long_state) button_long_state = false;
      //чтобы после входа в меню не кнопка "ОК" не считалась нажатой
      
      if (okSwitchState == HIGH && !button_state && !button_long_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_HEAT;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }

      break;
//устанавливаем температуру "Нижнего Нагревателя"
case REFLOW_STATE_MENU_BOTTOM_HEAT:

      if (updateScreen)
      {
        //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
        tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
        tft.print(" SET TEMP Bottom   ");       //lcd.print("Bottom Heat:      ");
        tft.setCursor(0*16+5, 2*48+48); //lcd.setCursor(2, 2);
        tft.print("Bottom Heat:   ");       //lcd.print("Bottom Heat:      ");
        updateScreen = false;
      }
      tft.setCursor(15*16, 2*48+48);   //lcd.setCursor(14, 2);
      tft.print(SP2);                  //lcd.print(SP2);

      if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        Setpoint2 = Setpoint2 + 10;
        if (Setpoint2 >= 350) { Setpoint2 = 350; }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        Setpoint2 = Setpoint2 - 10;
        if (Setpoint2 <= 60) { Setpoint2 = 60; }
      }

      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_PWR;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
      
 //устанавливаем максимальную мощность "НИЖНЕГО НАГРЕВАТЕЛЯ"     
   case REFLOW_STATE_MENU_BOTTOM_PWR:
      if (updateScreen)
      {
        tft.setCursor(0*16+5, 2*48+48);//lcd.setCursor(2, 2);
        tft.print("Bottom PWR:    ");//lcd.print("  Bottom PWR:    ");        
       updateScreen = false;
      }
        tft.setCursor(14*16, 2*48+48);//lcd.setCursor(13, 2);      
        tft.print(pwr_BOTTOM);//lcd.print(pwr_BOTTOM);
        tft.print("%  ");//lcd.print("%");
        /*if (pwr_BOTTOM<=99)
        {      
          tft.setCursor(16*16, 2*48+48);//lcd.setCursor(16,2);
          tft.print(" ");//lcd.print(" ");
        }
        if (pwr_BOTTOM<=9)
        {      
          tft.setCursor(15*16, 2*48+48);//lcd.setCursor(15,2);
          tft.print(" ");//lcd.print(" ");
        }*/
        
      
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        //pwr_BOTTOM = pwr_BOTTOM + 1;
        if (++pwr_BOTTOM >= 100) { pwr_BOTTOM = 100; }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        //pwr_BOTTOM = pwr_BOTTOM - 1;
        if (--pwr_BOTTOM <= 0) { pwr_BOTTOM = 0; }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_PWR;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

 //устанавливаем максимальную мощность "ВЕРХНЕГО НАГРЕВАТЕЛЯ"      
    case REFLOW_STATE_MENU_TOP_PWR:
      if (updateScreen)
      {   
        tft.setCursor(0*16+5, 2*48+48);//lcd.setCursor(2, 2);
        tft.print("   TOP PWR:     ");//lcd.print("   TOP PWR:    ");        
        updateScreen = false;
      }
      tft.setCursor(14*16, 2*48+48);//lcd.setCursor(13, 2);      
      tft.print(pwr_TOP);//lcd.print(pwr_TOP);
      tft.print("%  ");//lcd.print("%");      
      /*if (pwr_TOP<=99)
      {      
        tft.setCursor(16*16, 2*48+48);//lcd.setCursor(16,2);
        tft.print("   ");//lcd.print(" ");
      }
      if (pwr_TOP<=9)
      {      
        tft.setCursor(15*16, 2*48+48);///lcd.setCursor(15,2);
        tft.print("   ");//lcd.print(" ");
      }*/
      
      
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        //pwr_TOP = pwr_TOP + 1;
        if (++pwr_TOP >= 100) { pwr_TOP = 100; }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        //pwr_TOP = pwr_TOP - 1;
        if (--pwr_TOP <= 0) { pwr_TOP = 0; }
      }
      
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_STEP_RAMP;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//устанавливаем скорость нагрева "Верхним Нагревателем"
case REFLOW_STATE_MENU_STEP_RAMP:

      if (updateScreen)
      {
        //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
        tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
        tft.print(" TEMP SPEED "); tft.print(char(31)); tft.print("     ");//lcd.print("Bottom Heat:      ");
        tft.setCursor(0*16+5, 2*48+48); //lcd.setCursor(2, 2);
        tft.print("Step:  Ramp:       ");           //lcd.print("Step ");
        tft.setCursor(6*16+5, 2*48+48); //lcd.setCursor(2, 2);
        tft.print(editStep + 1);      //lcd.print(editStep + 1);
        //tft.print("");    //lcd.print(" Ramp:      ");
        updateScreen = false;
      }
      tft.setCursor(14*16, 2*48+48);  //lcd.setCursor(14, 2);
      tft.print(rampRateStep[editStep] / 4);//lcd.print(rampRateStep[editStep] / 4);
      tft.print(" ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        //rampRateStep[editStep] = rampRateStep[editStep] + 1.;
        if (++rampRateStep[editStep] >= 12.)  //(только целые числа) максимальная скорость роста температуры делённая на 4
        {
          rampRateStep[editStep] = 12.;  //(только целые числа) максимальная скорость роста температуры делённая на 4
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        //rampRateStep[editStep] = rampRateStep[editStep] - 1.;
        if (--rampRateStep[editStep] <= 1.)  //(только целые числа) минимальная скорость роста температуры делённая на 4
        {
          rampRateStep[editStep] = 1.;  //(только целые числа) минимальная скорость роста температуры делённая на 4
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps) {
          editStep = 0;
          reflowState = REFLOW_STATE_MENU_STEP_TARGET;
        }
        else
        {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        //lcd.clear();   fillRect ??????
        tft.fillRect(0, 48, 320, 240-48, Bkgrnd_color);//lcd.clear();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//устанавливаем температуру "Верхнего Нагревателя"
case REFLOW_STATE_MENU_STEP_TARGET:
      if (updateScreen) 
      {
        //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
        tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
        tft.print(" SET Top TEMP      ");       //lcd.print("Bottom Heat:      ");
        tft.setCursor(0*16+5, 2*48+48);//lcd.setCursor(2, 2);
        tft.print("Step:   ");
        tft.print(char(30));
        tft.print("TEMP:   ");          //lcd.print("Step ");
        tft.setCursor(6*16+5, 2*48+48);
        tft.print(editStep + 1);//lcd.print(editStep + 1);
        //tft.print(" Target: ");//lcd.print(" Target: ");
        tft.setCursor(16*16, 2*48+48);
        tft.print(temperatureStep[editStep]);//lcd.print(temperatureStep[editStep]);
        tft.print("  ");//lcd.print(" ");
        updateScreen = false;
      }
      tft.print("  ");//lcd.print(" ");
      tft.setCursor(16*16, 2*48+48);//lcd.setCursor(16, 2);
      tft.print(temperatureStep[editStep]);//lcd.print(temperatureStep[editStep]);
      tft.print("  ");//lcd.print(" ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        temperatureStep[editStep] = temperatureStep[editStep] + 1;
        if (temperatureStep[editStep] >= 270)
        {
          temperatureStep[editStep] = 270;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        temperatureStep[editStep] = temperatureStep[editStep] - 1;
        if (temperatureStep[editStep] <= 0)
        {
          temperatureStep[editStep] = 0;
        }
        if (temperatureStep[editStep] <= 99)
        {
          tft.setCursor(18*16, 2*48+48);//lcd.setCursor(18, 2);
          tft.print("  ");//lcd.print(" ");
        }
        if (temperatureStep[editStep] <= 9)
        {
          tft.setCursor(17*16, 2*48+48);//lcd.setCursor(17, 2);
          tft.print("  ");//lcd.print(" ");
        }
      }

      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps)
        {
          editStep = 0;
          reflowState = REFLOW_STATE_MENU_STEP_DWELL;
        }
        else
        {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
      ///////////////////////////////////////
//устанавливаем время перехода на следующий шаг
case REFLOW_STATE_MENU_STEP_DWELL:

      if (updateScreen) 
      {
        //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
        tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
        tft.print(" Time next step   ");//lcd.print("Bottom Heat:      ");
        tft.setCursor(0*16+5, 2*48+48);//lcd.setCursor(1, 2);
        tft.print("Step:");//lcd.print("Step ");
        tft.print(editStep + 1); //lcd.print(editStep + 1);
        tft.print(" ");          
        tft.setCursor(9*16, 2*48+48);
        tft.print("Time: ");//tft.print(" Dwell: ");       //lcd.print(" Dwell: ");
        tft.setCursor(15*16, 2*48+48);
        tft.print(dwellTimerStep[editStep]);//lcd.print(dwellTimerStep[editStep]);
        tft.print("     ");              //lcd.print(" ");
      }
      //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
      //tft.print(" ");                //lcd.print(" ");
      tft.setCursor(15*16, 2*48+48);//lcd.setCursor(15, 2);
      tft.print(dwellTimerStep[editStep]);//lcd.print(dwellTimerStep[editStep]);
      tft.print("     ");//lcd.print(" ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        dwellTimerStep[editStep] = dwellTimerStep[editStep] + 5;
        if (dwellTimerStep[editStep] >= 100)
        {
          dwellTimerStep[editStep] = 100;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        dwellTimerStep[editStep] = dwellTimerStep[editStep] - 5;
        if (dwellTimerStep[editStep] <= 0)
        {
          dwellTimerStep[editStep] = 0;
        }

      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps) {

          editStep = 0;
          reflowState = REFLOW_STATE_MENU_BOTTOM_P;
        }
        else {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
      /////////////////////////////
//настройка "ПИД" нижнего нагревателя
case REFLOW_STATE_MENU_BOTTOM_P:
      if (updateScreen)
      {
        //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
        tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
        tft.print("        PID        ");       //lcd.print("Bottom Heat:      ");
        tft.setCursor(0*16+5, 2*48+48);//lcd.setCursor(0, 2);
        tft.print("                  ");//lcd.print("                  ");
        tft.setCursor(1*16, 2*48+48);//lcd.setCursor(3, 2);
        tft.print("Bottom Heater:");//lcd.print("Bottom Heater:");
        tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
        tft.print("P= ");//lcd.print("P=");
        tft.setCursor(11*16, 3*48+48);
        tft.print(kp2);//lcd.print(kp2);
        tft.print("  ");//lcd.print(" ");*/
        updateScreen = false;
      }
      //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
      tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
      tft.print(kp2);//lcd.print(kp2);
      tft.print("  ");//lcd.print("  ");
      
      if (upSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        //kp2 = kp2 + 1;
        if (++kp2 >= 500) { kp2 = 500; }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        //kp2 = kp2 - 1;
        if (--kp2 <= 0) { kp2 = 0; }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_I;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
    ///////////////////////////////  
case REFLOW_STATE_MENU_BOTTOM_I:
      tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
      tft.print("        PID        ");       //lcd.print("Bottom Heat:      ");
      tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
      tft.print("I= ");//lcd.print("I=");
      tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
      tft.print(ki2/10);//lcd.print(ki2);
      tft.print(" ");//lcd.print(" ");
           
      if (upSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        //ki2 = ki2 + 1;
        if (++ki2 >= 500) { ki2 = 500; }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        //ki2 = ki2 - 1;
        if (--ki2 <= 0) { ki2 = 0; }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_BOTTOM_D;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
/////////////////////////////
case REFLOW_STATE_MENU_BOTTOM_D:
      tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
      tft.print("        PID        ");
      tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
      tft.print("D= ");//lcd.print("D=");
      tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
      tft.print(kd2);//lcd.print(kd2);
      tft.print(" ");//lcd.print(" ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        //kd2 = kd2 + 1;
        if (++kd2 >= 500) { kd2 = 500; }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        //kd2 = kd2 - 1;
        if (--kd2 <= 0) { kd2 = 0; }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_TOP_P;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
      //////////////////////////////
//настройка "ПИД" верхнего нагревателя
case REFLOW_STATE_MENU_TOP_P:
      if (updateScreen)
      {
        //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
        tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
        tft.print("        PID        ");       //lcd.print("Bottom Heat:      ");
        tft.setCursor(0*16+5, 2*48+48);//lcd.setCursor(0, 2);
        tft.print("                  ");//lcd.print("                  ");
        tft.setCursor(3*16, 2*48+48);//lcd.setCursor(3, 2);
        tft.print("TOP Heater:   ");//lcd.print("Bottom Heater:");
        tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
        tft.print("P= ");//lcd.print("P=");
        tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
        tft.print(kp1);//lcd.print(kp1);
        tft.print(" ");//lcd.print(" ");*/
        updateScreen = false;
      }
      //tft.setTextColor(ILI9341_RED, Bkgrnd_color);  tft.setTextSize(3);
      tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
      tft.print(kp1);//lcd.print(kp2);
      tft.print("  ");//lcd.print("  ");

      if (upSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        //kp1 = kp1 + 1;
        if (++kp1 >= 500) { kp1 = 500; }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        //kp1 = kp1 - 1;
        if (--kp1 <= 0) { kp1 = 0; }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_I;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
      ///////////////////////////
case REFLOW_STATE_MENU_TOP_I:
        tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
        tft.print("        PID        ");       //lcd.print("Bottom Heat:      ");
        tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
        tft.print("I= ");//lcd.print("I=");
        tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
        tft.print(ki1/10);//lcd.print(ki1);
        tft.print(" ");//lcd.print(" ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        //ki1 = ki1 + 1;
        if (++ki1 >= 500) { ki1 = 500; }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        //ki1 = ki1 - 1;
        if (--ki1 <= 0) { ki1 = 0; }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_TOP_D;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

case REFLOW_STATE_MENU_TOP_D:
      tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
      tft.print("        PID        ");
      tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
      tft.print("D=");//lcd.print("D=");
      tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
      tft.print(kd1);//lcd.print(kd1);
      tft.print(" ");//lcd.print(" ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        //kd1 = kd1 + 1;
        if (++kd1 >= 500) { kd1 = 500; }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        //kd1 = kd1 - 1;
        if (--kd1 <= 0) { kd1 = 0; }

      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)
      {        
        ms_button =  millis();
        button_state = false;
        //сохраняем текущие параметры в "Память"
/*!!!*/ saveProfile();
        //tft.fillRect(0, 48, 320, 240-96, Bkgrnd_color);//lcd.clear();
        reflowState = REFLOW_STATE_IDLE;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        //lcd.clear();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//"процесс пайки", рост температуры с заданной скоростью
case REFLOW_STATE_STEP_RAMP:
      //currentStep = 1;
      if (updateScreen)
     {
       tft.setTextColor(ILI9341_GREEN, Bkgrnd_color);
       tft.setCursor(8*16, 0*48+48); //lcd.setCursor(8, 0);6
       tft.print("RUN!");            //lcd.print("RUN! ");
       tft.setTextColor(ILI9341_RED, Bkgrnd_color);
       updateScreen = false;
     }
     
    if (tc1>=Setpoint2 - 1 && !TopStart) TopStart = true;  //если температура низа вышла на уставку
    if (TopStart ==true)   // включаем верхний нагреватель
     
//фиксируем стартовую температуру      
      if (flag == 0)
      {
        startTemp = tc1;
        flag = 1;
      }
//устанавливаем нужный шаг, до которой нагрета плата      
      if (startTemp > temperatureStep[currentStep -1])
      {
        for (x=1; startTemp > temperatureStep[currentStep - 1];currentStep++)
        {
          x++;
        }
      }      
      if (currentStep > x && flag == 1)
      {
        flag = 0;
        startTemp = temperatureStep[currentStep - 2];        
        flag = 1;
      }
      tft.setCursor(18*16, 1*48+48);//lcd.setCursor(16, 1);
      tft.print(currentStep);//lcd.print(currentStep);
      tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
      tft.print(SP2);//lcd.print(SP2);
     // ramp rate counter;
      
//счётчик скорости роста температуры                  
      if ((currentMillis - previousMillis) > 4000 / rampRateStep[currentStep - 1])
      { //seconds counter
        previousMillis = currentMillis;
        counter = counter + 1;
        setpointRamp = counter + startTemp;
        tft.setCursor(8*16, 2*48+48);//lcd.setCursor(8, 2);
        tft.print("   ");//lcd.print("   ");       
        tft.setCursor(8*16, 8*48+48);//lcd.setCursor(8, 2);
        tft.print(setpointRamp);//lcd.print(setpointRamp);
        tft.print("  ");//lcd.print("  ");
        Setpoint1 = setpointRamp;
      }
      if (setpointRamp >= temperatureStep[currentStep - 1]) //если достигли нужной температуры
      {
        tft.setCursor(8*16, 2*48+48);//lcd.setCursor(8, 2);
        tft.print(temperatureStep[currentStep - 1]);//lcd.print(temperatureStep[currentStep - 1]);
        reflowState = REFLOW_STATE_STEP;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        //currentStep = 1;
        //counter = 0;
        //setpointRamp = 0;
        //x = 1;             //устанавливаем переменную в исходное состояние
        //flag = 0;         //после отановки профиля сбрасываем флаг
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
        updateScreen = true;
      }
      break;

case REFLOW_STATE_STEP:
      Setpoint1 = temperatureStep[currentStep - 1];
      if (Input1 >= temperatureStep[currentStep - 1])
      {
        counter = 0;
        reflowState = REFLOW_STATE_STEP_DWELL;        
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        updateScreen = true;
        //currentStep = 1;
        //counter = 0;
       // setpointRamp = 0;
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//считаем время перехода на следующий шаг
case REFLOW_STATE_STEP_DWELL:
      if (currentMillis - previousMillis > 1000) 
      {
        previousMillis = currentMillis;
        counter = counter + 1;
      }
      if (counter == dwellTimerStep[currentStep - 1]) //если счётчик равен установленному времени
      {
        counter = 0;
        setpointRamp = 0;
        if (profileSteps == currentStep) //если достигли последнего шага 
        {
          currentStep = 1;
          x = 1;      //устанавливаем переменную в исходное состояние
          flag = 0;   //после завершения профиля сбрасываем флаг
          reflowState = REFLOW_STATE_COMPLETE;
        }
        else //если шаг не последний
        {          
          currentStep++; //переходим на следующий шаг
          reflowState = REFLOW_STATE_STEP_RAMP;          
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
      {
        ms_button =  millis();
        updateScreen = true;
        //currentStep = 1;
        //counter = 0;
        //setpointRamp = 0;
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//завершение пайки      
    case REFLOW_STATE_COMPLETE:
      
      reflowStatus = REFLOW_STATUS_OFF;
      reflowState = REFLOW_STATE_IDLE;      
      updateScreen = true;
      break;
  }
  
//включение нагревателей
  if (reflowStatus == REFLOW_STATUS_ON)
  { 
    if (millis() > nextRead2)
    {
      Input1 = thermocouple2.readCelsius();
      Input2 = thermocouple2.readCelsius();
      tc1 = Input1;
      tc2 = Input2;
      
      nextRead2 += GRAPHICS_SAMPLING_TIME;
      if (curCount <= 7)
      {
        tft.setTextColor(ILI9341_MAGENTA, Bkgrnd_color);
        tft.setTextSize(2);
        tft.setCursor(curCount*12, 0*48+48);//lcd.setCursor(curCount, 0);
        tft.print(" *");//lcd.print(" *");
        tft.setCursor((24 - curCount)*12, 0*48+48);//lcd.setCursor(18 - curCount, 0);
        tft.print("* ");//lcd.print("* ");
        tft.setTextSize(3);
        tft.setTextColor(ILI9341_RED, Bkgrnd_color);
      }
      if (curCount > 7) 
      {
        tft.setTextColor(ILI9341_MAGENTA, Bkgrnd_color);
        tft.setTextSize(2);
        tft.setCursor((15 - curCount)*12, 0*48+48);//lcd.setCursor(13 - curCount, 0);
        tft.print("* ");//lcd.print("* ");
        tft.setCursor((curCount + 9)*12, 0*48+48);//lcd.setCursor(curCount + 5, 0);+
        tft.print(" *");//lcd.print(" *");
        tft.setTextSize(3);
        tft.setTextColor(ILI9341_RED, Bkgrnd_color);
      }
      curCount++;
      if (curCount > 14) curCount = 0;
    }
    if (millis() > nextRead1)
    {
      // Read thermocouples next sampling period
      nextRead1 += SENSOR_SAMPLING_TIME;
      tft.setTextSize(3);
      tft.setCursor(16*16+5, 2*48+48);//lcd.setCursor(16, 2);
      tft.print("   ");//lcd.print("    ");
      tft.setCursor(16*16+5, 2*48+48);//lcd.setCursor(16, 2);*/
      tft.print(tc1);  //lcd.print(tc1);
      tft.setCursor(16*16+5, 3*48+48);//lcd.setCursor(16, 3);
      tft.print("   ");//lcd.print("    ");
      tft.setCursor(16*16+5, 3*48+48);//lcd.setCursor(16, 3); */
      tft.print(tc2); //lcd.print(tc2);
    }
    myPID1.SetTunings(kp1, ki1, kd1);
    myPID2.SetTunings(kp2, ki2, kd2);
    myPID1.Compute();
    myPID2.Compute();
    attachInterrupt(1, Dimming, RISING); // настроить порт прерывания(0 или 1) 2й или 3й цифровой пин 
      /* -------------------------------------------------------------------------------
      LOW вызывает прерывание, когда на порту LOW
      CHANGE прерывание вызывается при смене значения на порту, с LOW на HIGH и наоборот
      RISING прерывание вызывается только при смене значения на порту с LOW на HIGH
      FALLING прерывание вызывается только при смене значения на порту с HIGH на LOW   
     ------------------------------------------------------------------------------- */

     if (!TopStart) Output1=0;
  }
  else
  {
    digitalWrite(RelayPin1, LOW);
    digitalWrite(RelayPin2, LOW);
  }


    /*if (millis() - windowStartTime > WindowSize)
    { //time to shift the Relay Window
      windowStartTime += WindowSize;
    }
//верхний нагреватель включится еcли температура "низа" достигнет 
//(установленной минус 10 градусов)    
    if ((tc2 >= (Setpoint2-10))&&(Output1> millis() - windowStartTime )) digitalWrite(RelayPin1, HIGH);
    else  digitalWrite(RelayPin1, LOW);
    if (Output2 > (millis() - windowStartTime)) digitalWrite(RelayPin2, HIGH);
    else digitalWrite(RelayPin2, LOW);
  }
  else
  {
    digitalWrite(RelayPin1, LOW);
    digitalWrite(RelayPin2, LOW);
  }*/
}

void Dimming()
{
  OutPWR_TOP();
  OutPWR_BOTTOM();
}
////////////////////////////
void OutPWR_TOP()
{
  reg1 = round(Output1*(pwr_TOP*0.01)) + er1; //pwr- задание выходной мощности в %, er- ошибка округления
     if (reg1 < 50)
       {
        out1=LOW;
        er1 = reg1 ; // reg- переменная для расчетов
       }
     else
       {
         out1=HIGH;
         er1=reg1-100;
       }
   digitalWrite(RelayPin1,out1);//пин через который осуществляется дискретное управление
}
////////////////////////////
void OutPWR_BOTTOM()
{
  reg2 = round(Output2*(pwr_BOTTOM*0.01)) + er2; //pwr- задание выходной мощности в %, er- ошибка округления
     if (reg2 < 50)
     {
       out2=LOW;
       er2 = reg2 ; // reg- переменная для расчетов
     }
     else
     {
       out2=HIGH;
       er2=reg2-100;
     }
   digitalWrite(RelayPin2,out2);//пин через который осуществляется дискретное управление
   //i++;
}


///////////////////////////////////////////////
void loadProfile()//this function loads whichever profile currentProfile variable is set to
{
  profileSteps = EEPROM.read((currentProfile - 1) * 29);
  Setpoint2 = EEPROM.read((currentProfile - 1) * 29 + 1);
  for (int i = 0; i < 9; i + 1) {
    rampRateStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 2);
    i++;
  }
  for (int i = 0; i < 9; i + 1) {
    dwellTimerStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 11) * 5;
    i++;
  }
  for (int i = 0; i < 9; i + 1) {
    temperatureStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 20);
    i++;
  }
  kp1 = EEPROM.read((currentProfile - 1) * 6 + 122);
  ki1 = EEPROM.read((currentProfile - 1) * 6 + 123);
  kd1 = EEPROM.read((currentProfile - 1) * 6 + 124);
  kp2 = EEPROM.read((currentProfile - 1) * 6 + 125);
  ki2 = EEPROM.read((currentProfile - 1) * 6 + 126);
  kd2 = EEPROM.read((currentProfile - 1) * 6 + 127);
  pwr_TOP = EEPROM.read((currentProfile - 1) * 6 + 128);
  pwr_BOTTOM = EEPROM.read((currentProfile - 1) * 6 + 129);

  return;
}

///////////////////////////////////////////////////////


void saveProfile()
{
  EEPROM.write((currentProfile - 1) * 29, profileSteps);
  EEPROM.write((currentProfile - 1) * 29 + 1, Setpoint2);
  for (int i = 0; i < 9; i + 1)
  {
    EEPROM.write(((currentProfile - 1) * 29 + i + 2), rampRateStep[i] );
    i++;
  }
  for (int i = 0; i < 9; i + 1) 
  {
    EEPROM.write(((currentProfile - 1) * 29 + i + 11), dwellTimerStep[i] / 5);
    i++;
  }
  for (int i = 0; i < 9; i + 1) 
  {
    EEPROM.write(((currentProfile - 1) * 29 + i + 20), temperatureStep[i]);
    i++;
  }
  EEPROM.write(((currentProfile - 1) * 6 + 122), kp1);
  EEPROM.write(((currentProfile - 1) * 6 + 123), ki1);
  EEPROM.write(((currentProfile - 1) * 6 + 124), kd1);
  EEPROM.write(((currentProfile - 1) * 6 + 125), kp2);
  EEPROM.write(((currentProfile - 1) * 6 + 126), ki2);
  EEPROM.write(((currentProfile - 1) * 6 + 127), kd2);
  EEPROM.write(((currentProfile - 1) * 6 + 128), pwr_TOP);
  EEPROM.write(((currentProfile - 1) * 6 + 129), pwr_BOTTOM);
}
//////////////////////////////////////////
float filter1(float val_1) {  //функция фильтрации показений "Верхней" термопары
  Pc1 = P1 + varProcess1;
  G1 = Pc1/(Pc1 + varTerm1);
  P1 = (1-G1)*Pc1;
  Xp1 = Xe1;
  Zp1 = Xp1;
  Xe1 = G1*(val_1-Zp1)+Xp1; // "фильтрованное" значение
  return(Xe1);
}

float filter2(float val_2) {  //функция фильтрации показений "Нижней" термопары
  Pc2 = P2 + varProcess2;
  G2 = Pc2/(Pc2 + varTerm2);
  P2 = (1-G2)*Pc2;
  Xp2 = Xe2;
  Zp2 = Xp2;
  Xe2 = G2*(val_2-Zp2)+Xp2; // "фильтрованное" значение
  return(Xe2);
}


